"use strict";
this.name = "MissileSummary";
this.author = "phkb";
this.copyright = "(C) 2023 phkb.";
this.license = "CC-NC-by-SA 4.0";
this.description = "Controls the equipment items to summarise missiles on the F5 Status screen";

this._missionScreen = false;
this._removeKeys = [];
this._knownKeys = {};
this._max = 0;

//-------------------------------------------------------------------------------------------------------------
this.startUpComplete = function () {
    var idx = 1;
    var found = true;
    var sc = worldScripts.ShipConfiguration_Core;
    do {
        found = false;
        var k = "EQ_MISSILESUMMARY_" + (idx < 10 ? "00" : (idx < 100 ? "0" : "")) + idx.toString();
        var ke = EquipmentInfo.infoForKey(k);
        if (ke) {
            this._knownKeys[ke.scriptInfo.missileKey] = k;
            found = true;
            if (sc) sc._ignoreEquip.push(k);
        }
        idx += 1;
    } while (found == true);
    this._max = idx - 1;
}

//-------------------------------------------------------------------------------------------------------------
this.missionScreenEnded = function () {
    this._missionScreen = false;
}

//-------------------------------------------------------------------------------------------------------------
this.guiScreenChanged = function (to, from) {
    if (to == "GUI_SCREEN_MISSION") {
        this._missionScreen = true;
        return;
    }
    var p = player.ship;
    if (to == "GUI_SCREEN_STATUS" && this._missionScreen == false) {
        if (p.missileCapacity > 0) {
            var flag = false;
            try {
                var miss = p.missiles;
                flag = true;
            } catch (err) {
                if (this._debug) log(this.name, "!!ERROR: " + err);
            }
            if (flag === true) {
                this._removeKeys.length = 0;
                for (var i = 0; i < miss.length; i++) {
                    //if (this._debug) log(this.name, p.missileCapacity + " - " + i + ": " + miss[i].equipmentKey);
                    var mk = miss[i].equipmentKey;
                    if (this._knownKeys[mk]) {
                        this._removeKeys.push(this._knownKeys[mk]);
                        p.awardEquipment(this._knownKeys[mk]);
                    }
                }
            }
        }
    }
    if (from == "GUI_SCREEN_STATUS") {
        var i = this._removeKeys.length;
        while (i--) {
            p.removeEquipment(this._removeKeys[i]);
        }
        this._removeKeys.length = 0;
    }
}

